//-----------------------------------------------------------------------------
/*
 * Description: This file contains the classes for setup
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   04.11.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-03-06 23:44:38 +0100 (Mo, 06 Mär 2006) $
 *   $Revision: 23 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxMenu_H__
#define __AxMenu_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- swap-workaround -------------------------------------------------------
#include "AxPluginGlobals.h"

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- local -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/menu.h>

//----- local -----------------------------------------------------------------
#include "AxPluginSetup.h"

//=============================================================================
//     forward declarations
//=============================================================================
class AxPluginSwitchOSDPos;
class AxMenuSetup;

//=============================================================================
//     typedefs
//=============================================================================

//=============================================================================
//     class AxMenuSetupCommon
//=============================================================================
class AxMenuSetupCommon : public cOsdMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef cOsdMenu PARENT;

  public:
    //-------------------------------------------------------------------------
    //     AxMenuSetupCommon()
    //-------------------------------------------------------------------------
    AxMenuSetupCommon(AxPluginSettings &theSettings);

    //-------------------------------------------------------------------------
    //     ~AxMenuSetupCommon()
    //-------------------------------------------------------------------------
    virtual ~AxMenuSetupCommon();

    //-------------------------------------------------------------------------
    //     ProcessKey()
    //-------------------------------------------------------------------------
    virtual eOSState ProcessKey(eKeys Key);

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxPluginSettings     &myEdtSettings;
    AxPluginSettings      myTmpSettings;

}; // class AxMenuSetupCommon

//=========================================================================
//     class AxMenuSetupOSDPreset
//=========================================================================
class AxMenuSetupOSDPreset : public cOsdMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef cOsdMenu PARENT;

  public:
    //-------------------------------------------------------------------------
    //     AxMenuSetupOSDPreset()
    //-------------------------------------------------------------------------
    AxMenuSetupOSDPreset(AxMenuSetup *myParent, AxOSDPreset &theOSDPreset);

    //-------------------------------------------------------------------------
    //     ~AxMenuSetupOSDPreset()
    //-------------------------------------------------------------------------
    virtual ~AxMenuSetupOSDPreset();

    //-------------------------------------------------------------------------
    //     ProcessKey()
    //-------------------------------------------------------------------------
    virtual eOSState ProcessKey(eKeys Key);

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxMenuSetup          *myParent;
    AxOSDPreset          &myEdtPreset;
    AxOSDPreset          &myTmpPreset;

    // temporary values used in the osd-items
    char myName[40];

}; // class AxMenuSetupPreset

//=============================================================================
//     class AxMenuSetup
//=============================================================================
class AxMenuSetup : public cMenuSetupPage
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef cMenuSetupPage PARENT;

  public:
    //-------------------------------------------------------------------------
    //     AxMenuSetup()
    //-------------------------------------------------------------------------
    AxMenuSetup(AxPluginSwitchOSDPos *thePlugin);

    //-------------------------------------------------------------------------
    //     ~AxMenuSetup()
    //-------------------------------------------------------------------------
    virtual ~AxMenuSetup();

    //-------------------------------------------------------------------------
    //     ProcessKey()
    //-------------------------------------------------------------------------
    virtual eOSState ProcessKey(eKeys Key);

    //-------------------------------------------------------------------------
    //     Store()
    //-------------------------------------------------------------------------
    virtual void Store(void);

  protected:
    //-------------------------------------------------------------------------
    //     Move()
    //-------------------------------------------------------------------------
    virtual void Move(int From, int To);

  private:
    //-------------------------------------------------------------------------
    //     setup()
    //-------------------------------------------------------------------------
    void setup(int theCurrent = -1);

    //-------------------------------------------------------------------------
    //     setupColorButtons()
    //-------------------------------------------------------------------------
    void setupColorButtons();

    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxPluginSwitchOSDPos *myPlugin;

}; // class AxMenuSetup

//=============================================================================
//     class AxMenuSelect
//=============================================================================
class AxMenuSelect : public cOsdMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef cOsdMenu PARENT;

  public:
    //-------------------------------------------------------------------------
    //     AxMenuSelect()
    //-------------------------------------------------------------------------
    AxMenuSelect(AxPluginSwitchOSDPos *thePlugin);

    //-------------------------------------------------------------------------
    //     ~AxMenuSelect()
    //-------------------------------------------------------------------------
    virtual ~AxMenuSelect();

    //-------------------------------------------------------------------------
    //     ProcessKey()
    //-------------------------------------------------------------------------
    virtual eOSState ProcessKey(eKeys Key);

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxPluginSwitchOSDPos *myPlugin;

}; // class AxMenuSelect

#endif

