//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxPluginSwitchOSDPos
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   04.11.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-02-21 21:01:37 +0100 (Di, 21 Feb 2006) $
 *   $Revision: 9 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxSwitchOSDPos_H__
#define __AxSwitchOSDPos_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- ICE -------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/plugin.h>
#include <vdr/device.h>
#include <vdr/thread.h>
#include <linux/dvb/video.h>

//----- local -----------------------------------------------------------------
#include "AxPluginSetup.h"

class cUpdateOsd : public cThread
{
public:
        cUpdateOsd();
        ~cUpdateOsd();

        void Exit(void);

protected:
        virtual void Action(void);

private:
        eVideoSystem GetVideoSystem(void);

        bool doexit;
        uint64 time;
        eVideoSystem curVidSys;
        bool initialized;
//      tOsdSettings pal;
//      tOsdSettings ntsc;

        // for the direct dvb-device-communication
        int dvbHandle;
        video_size_t videoSize;
};

//=============================================================================
//     class AxPluginSwitchOSDPos
//=============================================================================
class AxPluginSwitchOSDPos : public cPlugin
{
  public:
    //-------------------------------------------------------------------------
    //     AxPluginSwitchOSDPos()
    //-------------------------------------------------------------------------
    AxPluginSwitchOSDPos(void);

    //-------------------------------------------------------------------------
    //     ~AxPluginSwitchOSDPos()
    //-------------------------------------------------------------------------
    virtual ~AxPluginSwitchOSDPos();

    //-------------------------------------------------------------------------
    //     Version()
    //-------------------------------------------------------------------------
    virtual const char *Version(void);

    //-------------------------------------------------------------------------
    //     Description()
    //-------------------------------------------------------------------------
    virtual const char *Description(void);

    //-------------------------------------------------------------------------
    //     CommandLineHelp()
    //-------------------------------------------------------------------------
    virtual const char *CommandLineHelp(void);

    //-------------------------------------------------------------------------
    //     ProcessArgs()
    //-------------------------------------------------------------------------
    virtual bool ProcessArgs(int argc, char *argv[]);

    //-------------------------------------------------------------------------
    //     Initialize()
    //-------------------------------------------------------------------------
    virtual bool Initialize(void);

    //-------------------------------------------------------------------------
    //     Start()
    //-------------------------------------------------------------------------
    virtual bool Start(void);

    //-------------------------------------------------------------------------
    //     Stop()
    //-------------------------------------------------------------------------
    virtual void Stop(void);

    //-------------------------------------------------------------------------
    //     Housekeeping()
    //-------------------------------------------------------------------------
    virtual void Housekeeping(void);

    //-------------------------------------------------------------------------
    //     MainMenuEntry()
    //-------------------------------------------------------------------------
    virtual const char *MainMenuEntry(void);

    //-------------------------------------------------------------------------
    //     MainMenuAction()
    //-------------------------------------------------------------------------
    virtual cOsdObject *MainMenuAction(void);

    //-------------------------------------------------------------------------
    //     SetupMenu()
    //-------------------------------------------------------------------------
    virtual cMenuSetupPage *SetupMenu(void);

    //-------------------------------------------------------------------------
    //     SetupParse()
    //-------------------------------------------------------------------------
    virtual bool SetupParse(const char *Name, const char *Value);

    //-------------------------------------------------------------------------
    //     Service()
    //-------------------------------------------------------------------------
    virtual bool Service(const char *Id, void *Data = NULL);

    //-------------------------------------------------------------------------
    //     SVDRPHelpPages()
    //-------------------------------------------------------------------------
    virtual const char **SVDRPHelpPages(void);

    //-------------------------------------------------------------------------
    //     SVDRPCommand()
    //-------------------------------------------------------------------------
    virtual cString SVDRPCommand(const char *Command, const char *Option, int &ReplyCode);

    //-------------------------------------------------------------------------
    //     Setup()
    //-------------------------------------------------------------------------
    AxPluginSetup &Setup() { return mySetup; }

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    char            *myMainMenuEntry;
    cUpdateOsd       update;


    AxPluginSetup    mySetup;

}; // class AxPluginSwitchOSDPos


#endif

